
/**
 * This class models a simple calculator with some basic
 * functions: add, subtract, multiply, divide, convert to 
 * percentage and convert inches to centimeters
 * 
 * @author Chuck Hommel
 * @version 2012.10.11
 * number or a date)
 */
public class Calculator
{

    private int mem;    //memory - holds results of operations

    /**
     * Constructor for objects of class Calculator
     */
    public Calculator()
    {
        mem = 0;  // initialize memory accumulator
    }

    /** 
     * Add two integers and print the result
     * @param a first addend
     * @param b second addend
     * 
     */
    public void addInts(int a, int b)
    {
        int sum = a + b;
        System.out.println(a + " + " + b + " = " + sum);
    }

    /** 
     * Add two doubles and print the result
     * @param a first addend
     * @param b second addend
     * 
     */
    public void addDoubles(double a, double b)
    {
        double sum = a + b;
        System.out.println(a + " + " + b + " = " + sum);
    }

    /** 
     * Subtract two integers and print the result
     * @param a minuend
     * @param b subtrahend
     * 
     */
    public void subtractInts(int a, int b)
    {
        int diff = a - b;
        System.out.println(a + " - " + b + " = " + diff);
    }

    /** 
     * Subtract two doubles and print the result
     * @param a minuend
     * @param b subtrahend
     * 
     */
    public void subtractDoubles(double a, double b)
    {
        double diff = a - b;
        System.out.println(a + " - " + b + " = " + diff);
    }

    /** 
     * Multiply two doubles and print the result
     * @param a first factor
     * @param b second factor
     * 
     */
    public void multiplyDoubles(double a, double b)
    {
        double  product = a * b;
        System.out.println(a + " * " + b + " = " + product);
    }

    /** 
     * Divide two doubles and print the result
     * @param a dividend
     * @param b divisor
     * 
     */
    public void divideDoubles(double a, double b)
    {
        double  quotient = a * b;
        System.out.println(a + " / " + b + " = " + quotient);
    }

    /** 
     * Add two percentages and print the result
     * @param a first addend
     * @param b second addend
     * 
     */
    public void addPercentages(double a, double b)
    {
        double sum = a + b;
        System.out.println(a + "% + " + b + "% = " + sum + "%");
    }

    /** 
     * Compute a percentage
     * @param a first addend
     * @param b second addend
     * 
     */
    public void findPercentage(double quantity, double percentage)
    {
        double result = quantity * (percentage/100);
        System.out.println(percentage + "% of " + quantity + " = " + result);
    }

    /**
     * Convert inches to centimeters
     * @param inch number of inches to convert
     */
    public void converttoCentimeters(double inch)
    {
        System.out.println(inch + " in. = " + (2.54 * inch) + "cm.");
    }

    /** 
     * Add two doubles and print the result (decorated)
     * @param a first addend
     * @param b second addend
     * 
     */
    public void decorativeAdd(double a, double b)
    {
        double sum = a + b;
        System.out.println("~`~`~`~`~`~`");
        System.out.println(a + " + " + b + " = " + sum);
        System.out.println("~`~`~`~`~`~`");
    }
    
    /*******************************************
     * The next method returns the result of addition
     * It is a model for returning the result of other operations also.
     ***********************************************/

    /**
     * Compute the sum of two doubles
     * @param a first addend
     * @param b second addend
     */
    public double getSum(double a, double b)
    {
        return (a + b);
    }

    
    /*******************************************
     * The next method adds a value to the memory 
     * It is a model for  other memory operations also.
     ***********************************************/
     
     /** 
     * Add an integer to memory and print the result
     * @param a value to add to memory
     * 
     */
    public void addInt(int a)
    {
        System.out.print(mem + " + " + a + " = " );        
        mem = mem + a;
        System.out.println(mem);
    }

}
